create or replace PROCEDURE run_objdemo is
  l_address o_address;
  l_account_type VARCHAR2(5);
  l_o_account o_account;
  l_limit NUMBER;
  l_ssn VARCHAR2(10);
  l_amount NUMBER;
  l_name VARCHAR2(50);
  l_gender CHAR;
  l_date DATE;
  l_actnum1 INTEGER;
  l_actnum2 INTEGER;
  l_actnum3 INTEGER;
  l_actnum4 INTEGER;
  l_actnum5 INTEGER;
  l_actnum6 INTEGER;


BEGIN

  -- opening procedure.

  DBMS_OUTPUT.PUT_LINE('--- Opening an account for James ---');

  l_o_account := o_account(NULL,v_account_type(NULL),NULL,NULL,NULL);
  l_name := 'James';
  l_date := to_date('20-AUG-77','dd-MON-yy');
  l_gender := 'M';
  l_address := o_address('A1234','SanthomeStreet','Redwood Shores','California',
        '94065');

  l_ssn := 'A1234';
  l_account_type := 'AT1';
  l_amount := 500;


  DBMS_OUTPUT.PUT_LINE('--- Opening an account of type AT1 for James ---');

  l_actnum1 := l_o_account.open_account(l_ssn,l_account_type,l_amount,
            l_name,l_date,l_gender,l_address);
  DBMS_OUTPUT.PUT_LINE('');

  l_ssn := 'A1234';
  l_account_type := 'AT2';
  l_amount := 500;

  DBMS_OUTPUT.PUT_LINE('--- Opening an account of type AT2 for James --- ');

  l_actnum2 := l_o_account.open_account(l_ssn,l_account_type,l_amount,
                null,null,null,null);

  DBMS_OUTPUT.PUT_LINE('');

  l_ssn := 'A1234';
  l_account_type := 'AT3';
  l_amount := 500;

  DBMS_OUTPUT.PUT_LINE('---  Opening an account of type AT3 for James ---');

  l_actnum3 := l_o_account.open_account(l_ssn,l_account_type,l_amount,
            null,null,null,null);
  DBMS_OUTPUT.PUT_LINE('');

  DBMS_OUTPUT.PUT_LINE('---  Deposit 1000 to James account- AT1 ----');

  l_o_account.deposit_amount(l_actnum1,1000);
  DBMS_OUTPUT.PUT_LINE('');

  DBMS_OUTPUT.PUT_LINE('---  Deposit 4000 to James account- AT1 ----');

  l_o_account.deposit_amount(l_actnum1,4000);
  DBMS_OUTPUT.PUT_LINE('');

  DBMS_OUTPUT.PUT_LINE('---  Deposit 2000 to James account- AT2 ----');

  l_o_account.deposit_amount(l_actnum2,2000);
  DBMS_OUTPUT.PUT_LINE('');

  DBMS_OUTPUT.PUT_LINE('--- Withdraw 500 from James account- in AT2 ---');

  l_o_account.withdraw_amount(l_actnum2,500);
  DBMS_OUTPUT.PUT_LINE('');

  DBMS_OUTPUT.PUT_LINE('--- Withdraw 1500 from James account- in AT1 ---');

  l_o_account.withdraw_amount(l_actnum1,1500);
  DBMS_OUTPUT.PUT_LINE('');


  DBMS_OUTPUT.PUT_LINE('---  Deposit 2500 to James account- AT1 ----');

  l_o_account.deposit_amount(l_actnum1,2500);
  DBMS_OUTPUT.PUT_LINE('');

  DBMS_OUTPUT.PUT_LINE('--- Withdraw 1500 from James account- in AT3 ---');

  l_o_account.withdraw_amount(l_actnum3,1500);
  DBMS_OUTPUT.PUT_LINE('');

  DBMS_OUTPUT.PUT_LINE('--- Withdraw 1750 from James account- in AT1 ---');

  l_o_account.withdraw_amount(l_actnum1,1750);
  DBMS_OUTPUT.PUT_LINE('');

  DBMS_OUTPUT.PUT_LINE('---Query for the current balance in James account---');
  l_o_account.current_balance(l_actnum1);

  DBMS_OUTPUT.PUT_LINE('');

  DBMS_OUTPUT.PUT_LINE('--Query the transaction details of James-----');

  l_o_account.trans_details(l_ssn);
  DBMS_OUTPUT.PUT_LINE('');

  DBMS_OUTPUT.PUT_LINE('--- Closing the account for James ---');
  l_o_account.close_account(l_actnum1);
  DBMS_OUTPUT.PUT_LINE('');

  l_name := 'John';
  l_date := to_date('20-AUG-78','dd-MON-yy');
  l_gender := 'M';
  l_address := o_address('B7896','Concurse Drive','Belmont','California',
                 '94065');

  l_ssn := 'B7896';
  l_account_type := 'AT2';
  l_amount := 2000;

  DBMS_OUTPUT.PUT_LINE('--- Opening an account of type AT1 for John ---');

  l_actnum1 := l_o_account.open_account(l_ssn,l_account_type,l_amount,
                  l_name,l_date,l_gender,l_address);

  DBMS_OUTPUT.PUT_LINE('');

  DBMS_OUTPUT.PUT_LINE('---  Withdrawing from John account ---');

  l_o_account.withdraw_amount(l_actnum1,1000);
  DBMS_OUTPUT.PUT_LINE('');

  DBMS_OUTPUT.PUT_LINE('---  Depositing 3000 in John account ---');

  l_o_account.deposit_amount(l_actnum1,3000);
  DBMS_OUTPUT.PUT_LINE('');

  DBMS_OUTPUT.PUT_LINE('----Details for John----');
  l_o_account.trans_details('B7896');

END;
